/*
 * WS2813.c
 *
 * Created: 12.12.2017 1:39:33
 *  Author: 1
 */ 
#define F_CPU 8000000
#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h> //  
// 
#define red 1
#define orange 2
#define yellow 3
#define green 4
#define cyan 5
#define blue 6
#define purple 7
#define white 8
#define none 9
//
signed char i=0,m=0,n=0;// 
//      INT0
ISR(INT0_vect)
{
	n++;             //  n
	if(n>3)n=0;
}
void _port_ini(void)
{
	// PA3  
	DDRB|=(1<<1);
	// PD2     
	DDRB&=~(1<<2);
	PORTB|=(1<<2);
}
//  .0  
void Send_bit_0(void)
{
	PORTB|=(1<<1);
	asm("nop");
	PORTB&=~(1<<1);
	asm("nop");
}
//  .1  
void Send_bit_1(void)
{
	PORTB|=(1<<1);
	for (i=0;i<2;i++)asm("nop");
	PORTB&=~(1<<1);
	asm("nop");
}
//  
void Send_Byte(unsigned char redshade, unsigned char greenshade, unsigned char blueshade)
{
	signed char i;
	for(i=7;i>=0;i--)
	{
		if(greenshade&(1<<i))Send_bit_1();
		else Send_bit_0();
	}
	for(i=7;i>=0;i--)
	{
		if(redshade&(1<<i))Send_bit_1();
		else Send_bit_0();
	}
	for(i=7;i>=0;i--)
	{
		if(blueshade&(1<<i))Send_bit_1();
		else Send_bit_0();
	}
}
// 
void Send_color(unsigned char c)
{
	switch(c)
	{
		case 1: Send_Byte(0x2F,0x00,0x00);break;//
		case 2: Send_Byte(0x2F,0x1E,0x00);break;//
		case 3: Send_Byte(0x2F,0x2F,0x00);break;//
		case 4: Send_Byte(0x00,0x2F,0x00);break;//
		case 5: Send_Byte(0x00,0x2F,0x2F);break;//
		case 6: Send_Byte(0x00,0x00,0x0F);break;//
		case 7: Send_Byte(0x2F,0x00,0x2F);break;//
		case 8: Send_Byte(0x2F,0x2F,0x2F);break;//
		case 9: Send_Byte(0x00,0x00,0x00);break;//  ()
		
	}
}
// 15 
void Serial_15_colors(char c1, char c2, char c3, char c4, char c5,
char c6, char c7, char c8, char c9, char c10,
char c11,char c12,char c13,char c14,char c15)
{
	Send_color(c1);
	Send_color(c2);
	Send_color(c3);
	Send_color(c4);
	Send_color(c5);
	Send_color(c6);
	Send_color(c7);
	Send_color(c8);
	Send_color(c9);
	Send_color(c10);
	Send_color(c11);
	Send_color(c12);
	Send_color(c13);
	Send_color(c14);
	Send_color(c15);
}
// 15 
void Serial_5_colors(char c1, char c2, char c3, char c4, char c5)
{
	Send_color(c1);
	Send_color(c2);
	Send_color(c3);
	Send_color(c4);
	Send_color(c5);
}
// 
void shift_white(void)
{
	Serial_15_colors(white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(blue,white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
	Serial_15_colors(white,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue,blue);
	_delay_ms(100);
}
// 
void shift_green(void)
{
	Serial_5_colors(white, white, white, white, white);
	_delay_ms(100);
	Serial_5_colors(green, white, white, white, white);
	_delay_ms(100);
	Serial_5_colors(white, green, white, white, white);
	_delay_ms(100);
	Serial_5_colors(white, white, green, white, white);
	_delay_ms(100);
	Serial_5_colors(white, white, white, green, white);
	_delay_ms(100);
	Serial_5_colors(white, white, white, white, green);
	_delay_ms(100);
	Serial_5_colors(white, white, white, white, white);
	_delay_ms(100);

}
//
void shift_rainbow(void)
{
	Serial_15_colors(red,none,none,none,none,none,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(orange,red,none,none,none,none,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(yellow,orange,red,none,none,none,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(green,yellow,orange,red,none,none,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(cyan,green,yellow,orange,red,none,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(blue,cyan,green,yellow,orange,red,none,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(cyan,blue,cyan,green,yellow,orange,red,none,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(purple,cyan,blue,cyan,green,yellow,orange,red,none,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(none,purple,cyan,blue,cyan,green,yellow,orange,red,none,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(none,none,purple,cyan,blue,cyan,green,yellow,orange,red,none,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(none,none,none,purple,cyan,blue,cyan,green,yellow,orange,red,none,none,none,none);
	_delay_ms(500);
	Serial_15_colors(none,none,none,none,purple,cyan,blue,cyan,green,yellow,orange,red,none,none,none);
	_delay_ms(500);
	Serial_15_colors(none,none,none,none,none,purple,cyan,blue,cyan,green,yellow,orange,red,none,none);
	_delay_ms(500);
}


void change_color(void)
{
	int shade;
	for(shade=0;shade<70;shade++)
	{
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		_delay_ms(50);
	}
	for(shade=70;shade>0;shade--)
	{
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		Send_Byte(shade,70-shade,0x2F);
		Send_Byte(0x2F,shade,0x2F);
		Send_Byte(0x2F,0x2F,70-shade);
		Send_Byte(shade,70-shade,shade);
		Send_Byte(70-shade,shade,0x2F);
		_delay_ms(50);
	}
}  //

int main(void)
{
	sei();//  
	//     INT0
	GIMSK|=(1<<INT0);//    INT0
	//      INT0
	MCUCR|=(1<<ISC01);//:    INT0
	_port_ini();
	_delay_ms(500);
	while(1)
	{
		switch (n)//  ,    "n"
		{
			case 0:shift_white();break;
			case 1:shift_green();break;
			case 2:shift_rainbow();break;
			case 3:change_color();break;
		}
		
		
	}
}
